﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Audio;

namespace Shaed
{
    class Assets
    {
        // Scenes
        public static Scene introScene;
        public static Scene level01;

        // Textures
        public static Texture2D tiles;
        public static Texture2D sprites;
        public static Texture2D platformerLevel01;
        public static Texture2D fontTexture;
        public static Texture2D wraith;
        public static Texture2D newGameButton;

        // Audio
        public static SoundEffect wraithJump;
        public static SoundEffect powerup;
        public static SoundEffect brick;

        // Fonts
        public static Font font;

        // Load Game Assets
        public static void Load()
        {
            // Textures
            wraith = LoadImage(Program.game.GraphicsDevice, @"images/mario.png");
            platformerLevel01 = LoadImage(Program.game.GraphicsDevice, @"images/platformerLevel01.png");
            tiles = LoadImage(Program.game.GraphicsDevice, @"images/tiles.png");
            sprites = LoadImage(Program.game.GraphicsDevice, @"images/sprites.png");
            newGameButton = LoadImage(Program.game.GraphicsDevice, @"images/platformerLevel01.png");

            // Sounds
            Stream stream = File.OpenRead(@"audio/LTTP_Sword1.wav");
            stream = File.OpenRead(@"audio/wraithJump.wav");
            wraithJump = SoundEffect.FromStream(stream);
            
            stream = File.OpenRead(@"audio/powerup.wav");
            powerup = SoundEffect.FromStream(stream);

            stream = File.OpenRead(@"audio/brick.wav");
            brick = SoundEffect.FromStream(stream);

            // Fonts
            fontTexture = LoadImage(Program.game.GraphicsDevice, @"images/font.png");
            font = new Font(fontTexture, 256, 256, 16);

            // Intro Scene
            introScene = new Scenes.MainMenu();
            level01 = new Scenes.Platformer();
        }

        // Load Image
        public static Texture2D LoadImage(GraphicsDevice graphicsDevice, string filename)
        {
            FileStream setStream = File.Open(filename, FileMode.Open);
            Texture2D NewTexture = Texture2D.FromStream(Program.game.GraphicsDevice, setStream);
            setStream.Dispose();
            return NewTexture;
        }
    }
}
