﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Shaed.Engine.Prefabs
{
    class Button : GameObject
    {
        private readonly Func<string> Callback;

        public Button(Texture2D texture, Func<string> callback)
        {
            Callback = callback;
            sprite = new Sprite(texture, 0, 0, texture.Bounds.Width, texture.Bounds.Height);
            transform = new Transform(0, 0, texture.Bounds.Width, texture.Bounds.Height);
            transform.origin = new Vector2(0, 0);
        }

        public override void Click()
        {
            Callback();
        }
    }
}
