﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Shaed.Engine.Prefabs;

namespace Shaed.Scenes
{
    class MainMenu : Scene
    {
        public MainMenu()
        {
            name = "Main Menu"; new Scenes.Platformer();
            bounds = new Rectangle(0, 0, 1920, 1080);
            backgroundColor = Color.LightBlue;
            camera = new Camera(this);
            camera.Zoom(1);
        }

        public override void Load()
        {
            // New Game Button
            Engine.Prefabs.Button newGameButton = new Engine.Prefabs.Button(Assets.newGameButton, NewGameButtonClicked);
            AddUIObject(newGameButton, this, 32, 32);
        }

        public string NewGameButtonClicked()
        {
            LoadScene(Assets.level01);
            return null;
        }

        // Update
        public override void Update(GameTime gameTime)
        {
            // Controls
            if (Controller.IsKeyDown(Keys.Escape)) // Exit game
            {
                Program.game.Exit();
            }

            // Mouse Clicks
            if (Controller.IsLeftButtonUp())
            {
                ClickUIObjects(Controller.GetMousePosition());
            }
        }
    }
}
